#ifndef OBJECT_HPP_INCLUDED
#define OBJECT_HPP_INCLUDED


#include"imp.hpp"
#include"drawer.hpp"
#include"controller.hpp"
#include"rep.hpp"
#include<list>


template<typename  T>
bool
remove(std::list<T*>&  ls, const T*  const ptr)
{
  auto   it = ls.begin();
  auto  end = ls.end();

    while(it != end)
    {
        if(*it == ptr)
        {
          ls.erase(it);

          return true;
        }


      ++it;
    }


  return false;
}


struct
Node
{
  static constexpr int  circle_radius = 8;

  Node*  parent;

  Point3D      offset_point;
  Point3D  calculated_point;

  pixel32_t  pixel;

  struct{
    int    relative_value;
    int  calculated_value;

  } h_angle, v_angle;


  int  terminate_flag;

  std::list<Node*>  children;


   Node();
  ~Node();


  void  append(Node&  child);

  void  cleanup_as_root(const Point3D&  center_point);
  void  cleanup_as_child(const Node&  root);

  void       draw_as_root(Drawer&  dr, const Point3D&  center_point, int  h_angle_base, int  v_angle_base);
  void      draw_as_child(Drawer&  dr, const Node&  root);
  void  draw_as_stepchild(Drawer&  dr, const Node&  root, const Node&  stepparent);

  static void  draw_line(Drawer&  dr, pixel32_t  pixel, int  x1, int  y1, int  z1, int  x2, int  y2, int  z2);

  static void  draw_circle(Drawer&  dr, pixel32_t  pixel, int xm, int ym, int r);
  static void  draw_ellipse_rect(Drawer&  dr, pixel32_t  pixel, int x0, int y0, int x1, int y1);

};




#endif




