#ifndef TRIPLECUBE_HPP_INCLUDED
#define TRIPLECUBE_HPP_INCLUDED


#include"cube.hpp"




struct
TripleCube
{
  static constexpr int  size = Cube::size*3;

  static Point3D  base_view_point;
  static Point3D     cursor_point;

  const Cube*  source_cube;

  Cube::Element  elements_[size*size*size];

  int  x_min;
  int  x_max;
  int  y_min;
  int  y_max;
  int  z_min;
  int  z_max;

  void  clear();

  void  assign(const Cube&  cube);

        Cube::Element&  get(int  x, int  y, int  z)      ;
  const Cube::Element&  get(int  x, int  y, int  z) const;

  void  update(Drawer&  dr, bool  xyz, bool  frame=false) const;

  void  rotate_horizontally(int  center_x, int  center_y, int  angle);
  void    rotate_vertically(int  center_x, int  center_z, int  angle);

};




#endif




